Subject: Re: [PATCH v5 4/7] powerpc/powernv: detect supported nest pmus and its events

From: Michael Ellerman <[email-masked]>
Date: Thu, 23 Jul 2015 19:11:12 +1000

On Thu, 2015-07-23 at 11:33 +0530, Madhavan Srinivasan wrote:
> 
> On Wednesday 22 July 2015 09:37 AM, Daniel Axtens wrote:
> >  
> >>  static struct perchip_nest_info p8_nest_perchip_info[P8_NEST_MAX_CHIPS];
> >> +static struct nest_pmu *per_nest_pmu_arr[P8_NEST_MAX_PMUS];
> >> +
> >> +static int nest_event_info(struct property *pp, char *name,
> >> +			struct nest_ima_events *p8_events, int string, u32 val)
> > 'int string' is a bit confusing. 'bool is_string' might be clearer, but
> > I think it would be even better still to have different functions for
> > string and non-string cases, especially because you only need val in the
> > non-string case.
> 
> I would perfer to be a single function, since most of the code is same
> just of the sting or val part. yes. We can make is as is_string and will
> add comment explaining what is done here? 

I think Daniel's right, it would be better as two functions.

The only part that is common after the if (string) check is the
p8_events->ev_value = buf assignment.

So you should be able to keep all the code up to the if (string) check in a
shared function and just have two wrappers that use it.

cheers